;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;  utilitization.lisp
;;;  Written by:  Shaul Markovitch
;;;  Last time modified: 10/1/2000
;;;  
;;;  
;;;  
;;;  This file contains the techniques used for utilization filtering
;;;  
;;;  
;;;

(defclass utilization-filter ()())


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; same-state-util-filter
;;; 
;;; This is the most trivial filter.  It allows only macros with the same
;;; start state as the current state.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; same-state-filter
;;; 
;;; Allow only macros with the same start state as the currnet state.
;;; Should be modified to utilize the machnisms for caching states.
;;; This should increase performance significantly
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defclass same-state (utilization-filter)())

(defmethod utilization-filtering
  ((filter same-state)
   macro-db state problem domain search-strategy)
  (declare (ignore problem search-strategy))
  (get-hashed-macros macro-db state domain))
 

